/*
 * tracker.c -- connection creator and connection status manager
 * Part of the tcpick project
 *
 * Author: Francesco Stablum <duskdruid @ despammed.com>
 *
 * Copyright (C) 2003, 2004  Francesco Stablum
 * Licensed under the GPL
 *
 */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "tcpick.h"
#include "extern.h"

struct conn_t * first_conn = NULL; /*all connections, ends on a 0*/
struct conn_t * last_conn  = NULL; 
int conn_num; /* number of active connections */


int 
status_switch(conn_t * conn ,int status) 
{
	display_status( stdout, conn, status );
/* FIXME: implementation ?? 
	if(! conn->file )
		open_file( conn ); 
	
	if( flags.writer.status ) {
		display_status( conn->client.file, conn, status );
		display_status( conn->server.file, conn, status);
	}
*/
	conn->status = status;
}

int 
newconn( conn_t * prev_ring )

{
	conn_t * conn;

	conn_num++;

	if( ( flags.trackfirst != -1      ) &&
	    ( conn_num > flags.trackfirst ) )
		return -1;
	
	conn = ( conn_t * )S_calloc( sizeof( conn_t ), 1 );
	
	prev_ring->next = conn; /* and the chain becomes longer... :)
				   thank you mainman for this good idea! */
	last_conn = conn;

	conn->client.side = CLIENT;
	conn->server.side = SERVER;

	conn->client.ip   = ippacket->ip_src.s_addr;
	conn->server.ip   = ippacket->ip_dst.s_addr;
	conn->client.port = tcppacket->source;
	conn->server.port = tcppacket->dest;
	
	conn->client.sip  = ntohl(tcppacket->seq) + 1;
	
	conn->client.oth = & (conn->server);
	conn->server.oth = & (conn->client);
	
	conn->num = conn_num; 
	
	status_switch( conn, SYN_SENT );
}

